// TsMedia.cpp: TSfBAbp[NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsMedia.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// CPesPacketNX̍\z/
/////////////////////////////////////////////////////////////////////////////

CPesPacket::CPesPacket()
	: CMediaData()
{
	Reset();
}

CPesPacket::CPesPacket(const DWORD dwBuffSize)
	: CMediaData(dwBuffSize)
{
	Reset();
}

CPesPacket::CPesPacket(const CPesPacket &Operand)
	: CMediaData()
{
	Reset();

	*this = Operand;
}

CPesPacket & CPesPacket::operator = (const CPesPacket &Operand)
{
	if (&Operand != this) {
		// CX^X̃Rs[
		CMediaData::operator = (Operand);
		m_Header = Operand.m_Header;
	}

	return *this;
}

const bool CPesPacket::ParseHeader(void)
{
	if(m_dwDataSize < 9UL)return false;														// PES_header_data_length܂ł6oCg
	else if(m_pData[0] != 0x00U || m_pData[1] != 0x00U || m_pData[2] != 0x01U)return false;	// packet_start_code_prefixُ
	else if((m_pData[6] & 0xC0U) != 0x80U)return false;										// Œrbgُ

	// wb_
	m_Header.byStreamID					= m_pData[3];										// +3 bit7-0
	m_Header.wPacketLength				= ((WORD)m_pData[4] << 8) | (WORD)m_pData[5];		// +4, +5
	m_Header.byScramblingCtrl			= (m_pData[6] & 0x30U) >> 4;						// +6 bit5-4
	m_Header.bPriority					= (m_pData[6] & 0x08U)? true : false;				// +6 bit3
	m_Header.bDataAlignmentIndicator	= (m_pData[6] & 0x04U)? true : false;				// +6 bit2
	m_Header.bCopyright					= (m_pData[6] & 0x02U)? true : false;				// +6 bit1
	m_Header.bOriginalOrCopy			= (m_pData[6] & 0x01U)? true : false;				// +6 bit0
	m_Header.byPtsDtsFlags				= (m_pData[7] & 0xC0U) >> 6;						// +7 bit7-6
	m_Header.bEscrFlag					= (m_pData[7] & 0x20U)? true : false;				// +7 bit5
	m_Header.bEsRateFlag				= (m_pData[7] & 0x10U)? true : false;				// +7 bit4
	m_Header.bDsmTrickModeFlag			= (m_pData[7] & 0x08U)? true : false;				// +7 bit3
	m_Header.bAdditionalCopyInfoFlag	= (m_pData[7] & 0x04U)? true : false;				// +7 bit2
	m_Header.bCrcFlag					= (m_pData[7] & 0x02U)? true : false;				// +7 bit1
	m_Header.bExtensionFlag				= (m_pData[7] & 0x01U)? true : false;				// +7 bit0
	m_Header.byHeaderDataLength			= m_pData[8];										// +8 bit7-0

	// wb_̃tH[}bgK`FbN
	if(m_Header.byScramblingCtrl != 0U)return false;	// Not scrambled ̂ݑΉ
	else if(m_Header.byPtsDtsFlags == 1U)return false;	// `̃tO

	return true;
}

void CPesPacket::Reset(void)
{
	// f[^NA
	ClearSize();
	::ZeroMemory(&m_Header, sizeof(m_Header));
}

const BYTE CPesPacket::GetStreamID(void) const
{
	// Stream IDԂ
	return m_Header.byStreamID;
}

const WORD CPesPacket::GetPacketLength(void) const
{
	// PES Packet LengthԂ
	return m_Header.wPacketLength;
}

const BYTE CPesPacket::GetScramblingCtrl(void) const
{	// PES Scrambling ControlԂ
	return m_Header.byScramblingCtrl;
}

const bool CPesPacket::IsPriority(void) const
{	// PES PriorityԂ
	return m_Header.bPriority;
}

const bool CPesPacket::IsDataAlignmentIndicator(void) const
{
	// Data Alignment IndicatorԂ
	return m_Header.bDataAlignmentIndicator;
}

const bool CPesPacket::IsCopyright(void) const
{
	// CopyrightԂ
	return m_Header.bCopyright;
}

const bool CPesPacket::IsOriginalOrCopy(void) const
{
	// Original or CopyԂ
	return m_Header.bOriginalOrCopy;
}

const BYTE CPesPacket::GetPtsDtsFlags(void) const
{
	// PTS DTS FlagsԂ
	return m_Header.byPtsDtsFlags;
}

const bool CPesPacket::IsEscrFlag(void) const
{
	// ESCR FlagԂ
	return m_Header.bEscrFlag;
}

const bool CPesPacket::IsEsRateFlag(void) const
{
	// ES Rate FlagԂ
	return m_Header.bEsRateFlag;
}

const bool CPesPacket::IsDsmTrickModeFlag(void) const
{
	// DSM Trick Mode FlagԂ
	return m_Header.bDsmTrickModeFlag;
}

const bool CPesPacket::IsAdditionalCopyInfoFlag(void) const
{
	// Additional Copy Info FlagԂ
	return m_Header.bAdditionalCopyInfoFlag;
}

const bool CPesPacket::IsCrcFlag(void) const
{
	// PES CRC FlagԂ
	return m_Header.bCrcFlag;
}

const bool CPesPacket::IsExtensionFlag(void) const
{
	// PES Extension FlagԂ
	return m_Header.bExtensionFlag;
}

const BYTE CPesPacket::GetHeaderDataLength(void) const
{
	// PES Header Data LengthԂ
	return m_Header.byHeaderDataLength;
}

const LONGLONG CPesPacket::GetPtsCount(void)const
{
	// PTS(Presentation Time Stamp)Ԃ
	if (m_Header.byPtsDtsFlags) {
		return HexToTimeStamp(&m_pData[9]);
	}

	// G[(PTSȂ)
	return -1LL;
}

const WORD CPesPacket::GetPacketCrc(void) const
{
	// PES Packet CRCԂ
	DWORD dwCrcPos = 9UL;

	// ʒuvZ
	if(m_Header.byPtsDtsFlags == 2U)dwCrcPos += 5UL;
	if(m_Header.byPtsDtsFlags == 3U)dwCrcPos += 10UL;
	if(m_Header.bEscrFlag)dwCrcPos += 6UL;
	if(m_Header.bEsRateFlag)dwCrcPos += 3UL;
	if(m_Header.bDsmTrickModeFlag)dwCrcPos += 1UL;
	if(m_Header.bAdditionalCopyInfoFlag)dwCrcPos += 1UL;

	if(m_dwDataSize < (dwCrcPos + 2UL))return 0x0000U;

	return ((WORD)m_pData[dwCrcPos] << 8) | (WORD)m_pData[dwCrcPos + 1];
}

BYTE * CPesPacket::GetPayloadData(void) const
{
	// yC[h|C^Ԃ
	const DWORD dwPayloadPos = m_Header.byHeaderDataLength + 9UL;

	return (m_dwDataSize >= (dwPayloadPos + 1UL))? &m_pData[dwPayloadPos] : NULL;
}

const DWORD CPesPacket::GetPayloadSize(void) const
{
	// yC[hTCYԂ(ۂ̕ێĂ@pPbg菭ȂȂ邱Ƃ)
	const DWORD dwHeaderSize = m_Header.byHeaderDataLength + 9UL;

	return (m_dwDataSize > dwHeaderSize)? (m_dwDataSize - dwHeaderSize) : 0UL;
}

inline const LONGLONG CPesPacket::HexToTimeStamp(const BYTE *pHexData)
{
	// 33bit 90KHz ^CX^v͂
	LONGLONG llCurPtsCount = 0LL;
	llCurPtsCount |= (LONGLONG)(pHexData[0] & 0x0EU) << 29;
	llCurPtsCount |= (LONGLONG)pHexData[1] << 22;
	llCurPtsCount |= (LONGLONG)(pHexData[2] & 0xFEU) << 14;
	llCurPtsCount |= (LONGLONG)pHexData[3] << 7;
	llCurPtsCount |= (LONGLONG)pHexData[4] >> 1;

	return llCurPtsCount;
}


//////////////////////////////////////////////////////////////////////
// CPesParserNX̍\z/
//////////////////////////////////////////////////////////////////////

CPesParser::CPesParser(IPacketHandler *pPacketHandler)
	: m_pPacketHandler(pPacketHandler)
	, m_PesPacket(0x10005UL)
	, m_bIsStoring(false)
	, m_wStoreCrc(0x0000U)
	, m_dwStoreSize(0UL)
{

}

CPesParser::CPesParser(const CPesParser &Operand)
{
	*this = Operand;
}

CPesParser & CPesParser::operator = (const CPesParser &Operand)
{
	if (&Operand != this) {
		// CX^X̃Rs[
		m_pPacketHandler = Operand.m_pPacketHandler;
		m_PesPacket = Operand.m_PesPacket;
		m_bIsStoring = Operand.m_bIsStoring;
		m_wStoreCrc = Operand.m_wStoreCrc;
	}

	return *this;
}

const bool CPesParser::StorePacket(const CTsPacket *pPacket)
{
	const BYTE *pData = pPacket->GetPayloadData();
	const BYTE bySize = pPacket->GetPayloadSize();
	if(!bySize || !pData)return false;

	bool bTrigger = false;
	BYTE byPos = 0U;

	if(pPacket->m_Header.bPayloadUnitStartIndicator){
		// wb_擪 + [yC[hf]

		// PESpPbgEȂ̃XgA
		if(m_bIsStoring && !m_PesPacket.GetPacketLength()){
			OnPesPacket(&m_PesPacket);
			}

		m_bIsStoring = false;
		bTrigger = true;
		m_PesPacket.ClearSize();

		byPos += StoreHeader(&pData[byPos], bySize - byPos);
		byPos += StorePayload(&pData[byPos], bySize - byPos);
		}
	else{
		// [wb_f] + yC[h + [X^btBOoCg]
		byPos += StoreHeader(&pData[byPos], bySize - byPos);
		byPos += StorePayload(&pData[byPos], bySize - byPos);
		}

	return bTrigger;
}

void CPesParser::Reset(void)
{
	// Ԃ
	m_PesPacket.Reset();
	m_bIsStoring = false;
	m_dwStoreSize = 0UL;
}

void CPesParser::OnPesPacket(const CPesPacket *pPacket) const
{
	// nhĂяo
	if(m_pPacketHandler)m_pPacketHandler->OnPesPacket(this, pPacket);
}

const BYTE CPesParser::StoreHeader(const BYTE *pPayload, const BYTE byRemain)
{
	// wb_͂ăZNṼXgAJn
	if(m_bIsStoring)return 0U;

	const BYTE byHeaderRemain = 9U - (BYTE)m_PesPacket.GetSize();

	if(byRemain >= byHeaderRemain){
		// wb_XgAAwb_͂ăyC[h̃XgAJn
		m_PesPacket.AddData(pPayload, byHeaderRemain);
		if(m_PesPacket.ParseHeader()){
			// wb_tH[}bgOK
			m_dwStoreSize = m_PesPacket.GetPacketLength();
			if(m_dwStoreSize)m_dwStoreSize += 6UL;
			m_bIsStoring = true;
			return byHeaderRemain;
			}
		else{
			// wb_G[
			m_PesPacket.Reset();
			return byRemain;
			}
		}
	else{
		// wb_XgAÃf[^҂
		m_PesPacket.AddData(pPayload, byRemain);
		return byRemain;
		}
}

const BYTE CPesParser::StorePayload(const BYTE *pPayload, const BYTE byRemain)
{
	// ZNṼXgA
	if(!m_bIsStoring)return 0U;
	
	const DWORD dwStoreRemain = m_dwStoreSize - m_PesPacket.GetSize();

	if(m_dwStoreSize && (dwStoreRemain <= (DWORD)byRemain)){
		// XgA
		m_PesPacket.AddData(pPayload, dwStoreRemain);

		// CRCAR[obNɃZNVn
		OnPesPacket(&m_PesPacket);

		// ԂÃZNVMɔ
		m_PesPacket.Reset();
		m_bIsStoring = false;

		return (BYTE)dwStoreRemain;
		}
	else{
		// XgAÃyC[h҂
		m_PesPacket.AddData(pPayload, byRemain);
		return byRemain;
		}
}


//////////////////////////////////////////////////////////////////////
// CAdtsFrameNX̍\z/
//////////////////////////////////////////////////////////////////////

CAdtsFrame::CAdtsFrame()
	: CMediaData()
{
	Reset();
}

CAdtsFrame::CAdtsFrame(const CAdtsFrame &Operand)
{
	Reset();

	*this = Operand;
}

CAdtsFrame & CAdtsFrame::operator = (const CAdtsFrame &Operand)
{
	if (&Operand != this) {
		// CX^X̃Rs[
		CMediaData::operator = (Operand);
		m_Header = Operand.m_Header;
	}

	return *this;
}

const bool CAdtsFrame::ParseHeader(void)
{
	// adts_fixed_header()
	if(m_dwDataSize < 7UL)return false;									// ADTSwb_7oCg
	else if(m_pData[0] != 0xFFU || m_pData[1] != 0xF8U)return false;	// SyncwordAIDAlayerAprotection_absentُ@CRCȂ͔Ή
	
	m_Header.byProfile				= (m_pData[2] & 0xC0U) >> 6;									// +2 bit7-6
	m_Header.bySamplingFreqIndex	= (m_pData[2] & 0x3CU) >> 2;									// +2 bit5-2
	m_Header.bPrivateBit			= (m_pData[2] & 0x02U)? true : false;							// +2 bit1
	m_Header.byChannelConfig		= ((m_pData[2] & 0x01U) << 2) | ((m_pData[3] & 0xC0U) >> 6);	// +3 bit0, +4 bit7-6
	m_Header.bOriginalCopy			= (m_pData[3] & 0x20U)? true : false;							// +3 bit5
	m_Header.bHome					= (m_pData[3] & 0x10U)? true : false;							// +3 bit4

	// adts_variable_header()
	m_Header.bCopyrightIdBit		= (m_pData[3] & 0x08U)? true : false;							// +3 bit3
	m_Header.bCopyrightIdStart		= (m_pData[3] & 0x04U)? true : false;							// +3 bit2
	m_Header.wFrameLength			= ((WORD)(m_pData[3] & 0x03U) << 11) | ((WORD)m_pData[4] << 3) | ((WORD)(m_pData[5] & 0xE0U) >> 5);
	m_Header.wBufferFullness		= ((WORD)(m_pData[5] & 0x1FU) << 6) | ((WORD)(m_pData[6] & 0xFCU) >> 2);
	m_Header.byRawDataBlockNum		= m_pData[6] & 0x03U;

	// tH[}bgK`FbN
	if(m_Header.byProfile == 3U)
		return false;		// `̃vt@C
	else if(m_Header.bySamplingFreqIndex > 0x0BU)
		return false;		// `̃TvOg
	else if(m_Header.byChannelConfig >= 3 && m_Header.byChannelConfig != 6)
		return false;		// `lُ
	else if(m_Header.wFrameLength < 2U || m_Header.wFrameLength > 0x2000 - 7)
		return false;		// f[^Ȃ̏ꍇŒCRC̃TCYKv
	else if(m_Header.byRawDataBlockNum)
		return false;		// {NX͒PRaw Data BlockɂΉȂ

	return true;
}

void CAdtsFrame::Reset(void)
{
	// f[^NA
	ClearSize();	
	::ZeroMemory(&m_Header, sizeof(m_Header));
}

const BYTE CAdtsFrame::GetProfile(void) const
{
	// Profile Ԃ
	return m_Header.byProfile;
}

const BYTE CAdtsFrame::GetSamplingFreqIndex(void) const
{
	// Sampling Frequency Index Ԃ
	return m_Header.bySamplingFreqIndex;
}

const DWORD CAdtsFrame::GetSamplingFreq(void) const
{
	static const DWORD FreqTable[] = {
		96000, 88200, 64000, 48000, 44100, 32000, 24000, 22050, 16000, 12000, 11025, 8000
	};
	return FreqTable[m_Header.bySamplingFreqIndex];
}

const bool CAdtsFrame::IsPrivateBit(void) const
{
	// Private Bit Ԃ
	return m_Header.bPrivateBit;
}

const BYTE CAdtsFrame::GetChannelConfig(void) const
{
	// Channel Configuration Ԃ
	return m_Header.byChannelConfig;
}

const bool CAdtsFrame::IsOriginalCopy(void) const
{
	// Original/Copy Ԃ
	return m_Header.bOriginalCopy;
}

const bool CAdtsFrame::IsHome(void) const
{
	// Home Ԃ
	return m_Header.bHome;
}

const bool CAdtsFrame::IsCopyrightIdBit(void) const
{
	// Copyright Identification Bit Ԃ
	return m_Header.bCopyrightIdBit;
}

const bool CAdtsFrame::IsCopyrightIdStart(void) const
{
	// Copyright Identification Start Ԃ
	return m_Header.bCopyrightIdStart;
}

const WORD CAdtsFrame::GetFrameLength(void) const
{
	// Frame Length Ԃ
	return m_Header.wFrameLength;
}

const WORD CAdtsFrame::GetBufferFullness(void) const
{
	// ADTS Buffer Fullness Ԃ
	return m_Header.wBufferFullness;
}

const BYTE CAdtsFrame::GetRawDataBlockNum(void) const
{
	// Number of Raw Data Blocks in Frame Ԃ
	return m_Header.byRawDataBlockNum;
}


//////////////////////////////////////////////////////////////////////
// CAdtsParserNX̍\z/
//////////////////////////////////////////////////////////////////////

CAdtsParser::CAdtsParser(IFrameHandler *pFrameHandler)
	: m_pFrameHandler(pFrameHandler)
{
	// ADTSt[ő咷̃obt@m
	m_AdtsFrame.GetBuffer(0x2000UL);

	Reset();
}

CAdtsParser::CAdtsParser(const CAdtsParser &Operand)
{
	*this = Operand;
}

CAdtsParser & CAdtsParser::operator = (const CAdtsParser &Operand)
{
	if (&Operand != this) {
		// CX^X̃Rs[
		m_pFrameHandler = Operand.m_pFrameHandler;
		m_AdtsFrame = Operand.m_AdtsFrame;
		m_bIsStoring = Operand.m_bIsStoring;
		m_wStoreCrc = Operand.m_wStoreCrc;
	}

	return *this;
}

const bool CAdtsParser::StorePacket(const CPesPacket *pPacket)
{
	return StoreEs(pPacket->GetPayloadData(), pPacket->GetPayloadSize());
}

const bool CAdtsParser::StoreEs(const BYTE *pData, const DWORD dwSize)
{
	if (pData == NULL || dwSize == 0)
		return false;

	bool bTrigger = false;
	DWORD dwPos = 0UL;

	do {
		if (!m_bIsStoring) {
			// wb_
			m_bIsStoring = SyncFrame(pData[dwPos++]);
			if(m_bIsStoring)bTrigger = true;
		} else {
			// f[^XgA
			const DWORD dwStoreRemain = m_AdtsFrame.GetFrameLength() - (WORD)m_AdtsFrame.GetSize();
			const DWORD dwDataRemain = dwSize - dwPos;

			if (dwStoreRemain <= dwDataRemain) {
				// XgA
				m_AdtsFrame.AddData(&pData[dwPos], dwStoreRemain);
				dwPos += dwStoreRemain;
				m_bIsStoring = false;

				// {Ȃ炱CRC`FbNׂ
				// `FbNΏۗ̈悪ςŕGȂ̂ŕۗAN܂...

				// t[o
				OnAdtsFrame(&m_AdtsFrame);

				// ̃t[邽߃Zbg
				m_AdtsFrame.ClearSize();
			} else {
				// XgAÃyC[h҂
				m_AdtsFrame.AddData(&pData[dwPos], dwDataRemain);
				break;
			}
		}
	} while (dwPos < dwSize);

	return bTrigger;
}

void CAdtsParser::Reset(void)
{
	// Ԃ
	m_bIsStoring = false;
	m_AdtsFrame.Reset();
}

void CAdtsParser::OnPesPacket(const CPesParser *pPesParser, const CPesPacket *pPacket)
{
	// CPesParser::IPacketHandlerC^tF[X̎
	StorePacket(pPacket);
}

void CAdtsParser::OnAdtsFrame(const CAdtsFrame *pFrame) const
{
	// nhĂяo
	if(m_pFrameHandler)m_pFrameHandler->OnAdtsFrame(this, pFrame);
}

inline const bool CAdtsParser::SyncFrame(const BYTE byData)
{
	switch (m_AdtsFrame.GetSize()) {
	case 0UL :
		// syncword(8bit)
		if (byData == 0xFFU)
			m_AdtsFrame.AddByte(byData);
		break;

	case 1UL :
		// syncword(4bit), ID, layer, protection_absent	CRCt̃t[̂ݑΉ
		if (byData == 0xF8U)
			m_AdtsFrame.AddByte(byData);
		else
			m_AdtsFrame.ClearSize();
		break;

	case 2UL :
	case 3UL :
	case 4UL :
	case 5UL :
		// adts_fixed_header() - adts_variable_header()
		m_AdtsFrame.AddByte(byData);
		break;

	case 6UL :
		// wb_SĂ
		m_AdtsFrame.AddByte(byData);

		// wb_͂
		if (m_AdtsFrame.ParseHeader())
			return true;
		m_AdtsFrame.ClearSize();
		break;

	default:
		// O
		m_AdtsFrame.ClearSize();
		break;
	}

	return false;
}


//////////////////////////////////////////////////////////////////////
// CMpeg2SequenceNX̍\z/
//////////////////////////////////////////////////////////////////////

CMpeg2Sequence::CMpeg2Sequence()
	: CMediaData()
{
	Reset();
}

CMpeg2Sequence::CMpeg2Sequence(const CMpeg2Sequence &Operand)
{
	Reset();

	*this = Operand;
}

CMpeg2Sequence & CMpeg2Sequence::operator = (const CMpeg2Sequence &Operand)
{
	if (&Operand != this) {
		// CX^X̃Rs[
		CMediaData::operator = (Operand);
		m_Header = Operand.m_Header;
	}

	return *this;
}

const bool CMpeg2Sequence::ParseHeader(void)
{
	// łStart Code PrifixStart Code`FbNȂB(V[PX݂̓̂ړIƂ)

	// next_start_code()
	DWORD dwHeaderSize = 12UL;
	if(m_dwDataSize < dwHeaderSize)return false;
	else if(m_pData[0] || m_pData[1] || m_pData[2] != 0x01U || m_pData[3] != 0xB3U)return false;					// +0,+1,+2,+3	

	ZeroMemory(&m_Header,sizeof(m_Header));
	m_Header.wHorizontalSize			= ((WORD)m_pData[4] << 4) | ((WORD)(m_pData[5] & 0xF0U) >> 4);				// +4,+5 bit7-4
	m_Header.wVerticalSize				= ((WORD)(m_pData[5] & 0x0FU) << 8) | (WORD)m_pData[6];						// +5 bit3-0, +6
	m_Header.byAspectRatioInfo			= (m_pData[7] & 0xF0U) >> 4;												// +7 bit7-4
	m_Header.byFrameRateCode			= m_pData[7] & 0x0FU;														// +7 bit3-0
	m_Header.dwBitRate					= ((DWORD)m_pData[8] << 10) | ((DWORD)m_pData[9] << 2) | ((DWORD)(m_pData[10] & 0xC0U) >> 6);	// +8, +9, +10 bit7-6
	m_Header.bMarkerBit					= (m_pData[10] & 0x20U)? true : false;										// +10 bit5
	m_Header.dwVbvBufferSize				= ((WORD)(m_pData[10] & 0x1FU) << 5) | ((WORD)(m_pData[11] & 0xF8U) >> 3);	// +10 bit4-0, +11 bit7-3
	m_Header.bConstrainedParamFlag		= (m_pData[11] & 0x04U)? true : false;										// +11 bit2
	m_Header.bLoadIntraQuantiserMatrix	= (m_pData[11] & 0x02U)? true : false;										// +11 bit1
	m_Header.bLoadNonIntraQuantiserMatrix=(m_pData[11] & 0x01U)? true : false;										// +11 bit0
	if (m_Header.bLoadIntraQuantiserMatrix) {
		dwHeaderSize += 64;
		if (m_dwDataSize < dwHeaderSize)
			return false;
	}
	if (m_Header.bLoadNonIntraQuantiserMatrix) {
		dwHeaderSize += 64;
		if (m_dwDataSize < dwHeaderSize)
			return false;
	}

	// tH[}bgK`FbN
	if (m_Header.wHorizontalSize == 0 || m_Header.wVerticalSize == 0)
		return false;
	if(!m_Header.byAspectRatioInfo || m_Header.byAspectRatioInfo > 4U)return false;		// AXyNg䂪ُ
	else if(!m_Header.byFrameRateCode || m_Header.byFrameRateCode > 8U)return false;	// t[[gُ
	else if(!m_Header.bMarkerBit)return false;											// }[J[rbgُ
	else if(m_Header.bConstrainedParamFlag)return false;								// Constrained Parameters Flag ُ

	// gwb_
	DWORD SyncState = 0xFFFFFFFF;
	for (DWORD i = dwHeaderSize; i < min(m_dwDataSize - 1, 1024UL);) {
		SyncState = (SyncState << 8) | m_pData[i++];
		if (SyncState == 0x000001B5UL) {
			// gwb_
			switch (m_pData[i] >> 4) {
			case 1:
				// V[PXg(48bits)
				if (i + 6 > m_dwDataSize)
					break;
				m_Header.Extention.Sequence.byProfileAndLevel = (m_pData[i + 0] & 0x0FU) << 4 | (m_pData[i + 1] >> 4);
				m_Header.Extention.Sequence.bProgressive = (m_pData[i + 1] & 0x08) != 0;
				m_Header.Extention.Sequence.byChromaFormat = (m_pData[i + 1] & 0x06U) >> 1;
				m_Header.wHorizontalSize |= (((m_pData[i + 1] & 0x01U) << 1) | ((m_pData[i + 2] & 0x80U) >> 7)) << 12;	// horizontal size extension
				m_Header.wVerticalSize   |= ((m_pData[i + 2] & 0x60U) >> 5) << 12;	// vertical size extension
				m_Header.dwBitRate |= (((DWORD)m_pData[i + 2] & 0x1FU) << 7) | (m_pData[i + 3] >> 1) << 18;	// bit rate extension
				if ((m_pData[i + 3] & 0x01U) == 0)	// marker bit
					break;
				m_Header.dwVbvBufferSize |= m_pData[i + 4] << 10;	// vbv buffer size extension
				m_Header.Extention.Sequence.bLowDelay = (m_pData[i + 5] & 0x80) != 0;
				m_Header.Extention.Sequence.byFrameRateExtN = (m_pData[i + 5] & 0x60U) >> 5;
				m_Header.Extention.Sequence.byFrameRateExtD = (m_pData[i + 5] & 0x18U) >> 3;
				m_Header.Extention.Sequence.bHave = true;
				i += 6;
				break;

			case 2:
				// fBXvCg(40bits(+24bits))
				if (i + 5 > m_dwDataSize)
					break;
				m_Header.Extention.Display.byVideoFormat = (m_pData[i + 0] & 0x0EU) >> 1;
				m_Header.Extention.Display.bColorDescrption = (m_pData[i + 0] & 0x01U) != 0;
				if (m_Header.Extention.Display.bColorDescrption) {
					if (i + 5 + 3 > m_dwDataSize)
						break;
					m_Header.Extention.Display.Color.byColorPrimaries = m_pData[i + 1];
					m_Header.Extention.Display.Color.byTransferCharacteristics = m_pData[i + 2];
					m_Header.Extention.Display.Color.byMatrixCoefficients = m_pData[i + 3];
					i += 3;
				}
				if ((m_pData[i + 2] & 0x02) == 0)	// marker bit
					break;
				if ((m_pData[i + 4] & 0x07) != 0)	// marker bit
					break;
				m_Header.Extention.Display.wDisplayHorizontalSize = ((WORD)m_pData[i + 1] << 6) | ((WORD)(m_pData[i + 2] & 0xFCU) >> 2);
				m_Header.Extention.Display.wDisplayVerticalSize   = ((WORD)(m_pData[i + 2] & 0x01U) << 13) | ((WORD)m_pData[i + 3] << 5) | ((WORD)(m_pData[i + 4] & 0xF8U) >> 3);
				m_Header.Extention.Display.bHave = true;
				i += 5;
				break;
			}
		}
	}

	return true;
}

void CMpeg2Sequence::Reset(void)
{
	// f[^NA
	ClearSize();
	::ZeroMemory(&m_Header, sizeof(m_Header));
}

const WORD CMpeg2Sequence::GetHorizontalSize(void) const
{
	// Horizontal Size Value Ԃ
	return m_Header.wHorizontalSize;
}

const WORD CMpeg2Sequence::GetVerticalSize(void) const
{
	// Vertical Size Value Ԃ
	return m_Header.wVerticalSize;
}

const BYTE CMpeg2Sequence::GetAspectRatioInfo(void) const
{
	// Aspect Ratio Information Ԃ
	return m_Header.byAspectRatioInfo;
}

const bool CMpeg2Sequence::GetAspectRatio(BYTE *pAspectX, BYTE *pAspectY) const
{
	BYTE AspectX, AspectY;

	switch (m_Header.byAspectRatioInfo) {
	case 1:
		AspectX = 1;
		AspectY = 1;
		break;
	case 2:
		AspectX = 4;
		AspectY = 3;
		break;
	case 3:
		AspectX = 16;
		AspectY = 9;
		break;
	case 4:
		AspectX = 221;
		AspectY = 100;
		break;
	default:
		return false;
	}
	if (pAspectX)
		*pAspectX = AspectX;
	if (pAspectY)
		*pAspectY = AspectY;
	return true;
}

const BYTE CMpeg2Sequence::GetFrameRateCode(void) const
{
	// Frame Rate Code Ԃ
	return m_Header.byFrameRateCode;
}

const bool CMpeg2Sequence::GetFrameRate(DWORD *pNum, DWORD *pDenom) const
{
	if (pNum == NULL || pDenom == NULL)
		return false;
	switch (m_Header.byFrameRateCode) {
	case 1:	// 23.976
		*pNum = 24000;
		*pDenom = 1001;
		break;
	case 2:
		*pNum = 24;
		*pDenom = 1;
		break;
	case 3:
		*pNum = 25;
		*pDenom = 1;
		break;
	case 4:	// 29.97
		*pNum = 30000;
		*pDenom = 1001;
		break;
	case 5:
		*pNum = 30;
		*pDenom = 1;
		break;
	case 6:
		*pNum = 50;
		*pDenom = 1;
		break;
	case 7:	// 59.94
		*pNum = 60000;
		*pDenom = 1001;
		break;
	case 8:
		*pNum = 60;
		*pDenom = 1;
		break;
	default:
		return false;
	}
	return true;
}

const DWORD CMpeg2Sequence::GetBitRate(void) const
{
	// Bit Rate Value Ԃ
	return m_Header.dwBitRate;
}

const bool CMpeg2Sequence::IsMarkerBit(void) const
{
	// Marker Bit Ԃ
	return m_Header.bMarkerBit;
}

const DWORD CMpeg2Sequence::GetVbvBufferSize(void) const
{
	// VBV Buffer Size Value Ԃ
	return m_Header.dwVbvBufferSize;
}

const bool CMpeg2Sequence::IsConstrainedParamFlag(void) const
{
	// Constrained Parameters Flag Ԃ
	return m_Header.bConstrainedParamFlag;
}

const bool CMpeg2Sequence::IsLoadIntraQuantiserMatrix(void) const
{
	// Load Intra Quantiser Matrix Ԃ
	return m_Header.bLoadIntraQuantiserMatrix;
}

const bool CMpeg2Sequence::GetExtendDisplayInfo() const
{
	// Extention Sequence Display 邩Ԃ
	return m_Header.Extention.Display.bHave;
}

const WORD CMpeg2Sequence::GetExtendDisplayHorizontalSize(void) const
{
	// Horizontal Size Value Ԃ
	return m_Header.Extention.Display.wDisplayHorizontalSize;
}

const WORD CMpeg2Sequence::GetExtendDisplayVerticalSize(void) const
{
	// Vertical Size Value Ԃ
	return m_Header.Extention.Display.wDisplayVerticalSize;
}



//////////////////////////////////////////////////////////////////////
// CMpeg2ParserNX̍\z/
//////////////////////////////////////////////////////////////////////

CMpeg2Parser::CMpeg2Parser(ISequenceHandler *pSequenceHandler)
	: m_pSequenceHandler(pSequenceHandler)
{
	Reset();
}

CMpeg2Parser::CMpeg2Parser(const CMpeg2Parser &Operand)
{
	*this = Operand;
}

CMpeg2Parser & CMpeg2Parser::operator = (const CMpeg2Parser &Operand)
{
	// CX^X̃Rs[
	if (&Operand != this) {
		m_pSequenceHandler = Operand.m_pSequenceHandler;
		m_Mpeg2Sequence = Operand.m_Mpeg2Sequence;
		//m_bIsStoring = Operand.m_bIsStoring;
		m_dwSyncState = Operand.m_dwSyncState;
	}

	return *this;
}

const bool CMpeg2Parser::StorePacket(const CPesPacket *pPacket)
{
	return StoreEs(pPacket->GetPayloadData(), pPacket->GetPayloadSize());
}

const bool CMpeg2Parser::StoreEs(const BYTE *pData, const DWORD dwSize)
{
	static const BYTE StartCode[] = {0x00U, 0x00U, 0x01U, 0xB3U};
	bool bTrigger = false;
	DWORD dwPos,dwStart;

	for (dwPos = 0UL; dwPos < dwSize; dwPos += dwStart) {
		// X^[gR[h
		//dwStart = FindStartCode(&pData[dwPos], dwSize - dwPos);
		DWORD Remain = dwSize - dwPos;
		DWORD SyncState = m_dwSyncState;
		for (dwStart = 0UL; dwStart < Remain; dwStart++) {
			SyncState=(SyncState<<8) | (DWORD)pData[dwPos + dwStart];
			if (SyncState == 0x000001B3UL) {
				// X^[gR[hAVtgWX^
				SyncState = 0xFFFFFFFFUL;
				break;
			}
		}
		m_dwSyncState = SyncState;

		if (dwStart < Remain) {
			dwStart++;
			if (m_Mpeg2Sequence.GetSize() >= 4UL) {
				if (dwStart < 4UL) {
					// X^[gR[h̒fЂ菜
					m_Mpeg2Sequence.TrimTail(4UL - dwStart);
				} else if (dwStart > 4UL) {
					m_Mpeg2Sequence.AddData(&pData[dwPos], dwStart - 4);
				}

				// V[PXo͂
				if (m_Mpeg2Sequence.ParseHeader())
					OnMpeg2Sequence(&m_Mpeg2Sequence);
			}

			// X^[gR[hZbg
			m_Mpeg2Sequence.SetData(StartCode, 4UL);
			bTrigger = true;
		} else {
			if (m_Mpeg2Sequence.GetSize() >= 4UL) {
				// V[PXXgA
				if (m_Mpeg2Sequence.AddData(&pData[dwPos], Remain) >= 0x1000000UL) {
					// O(V[PX16MB𒴂)
					m_Mpeg2Sequence.ClearSize();
				}
			}
			break;
		}
	}

	return bTrigger;
}

void CMpeg2Parser::Reset(void)
{
	// Ԃ
	//m_bIsStoring = false;
	m_dwSyncState = 0xFFFFFFFFUL;

	m_Mpeg2Sequence.Reset();
}

void CMpeg2Parser::OnPesPacket(const CPesParser *pPesParser, const CPesPacket *pPacket)
{
	// CPesParser::IPacketHandlerC^tF[X̎
	StorePacket(pPacket);
}

void CMpeg2Parser::OnMpeg2Sequence(const CMpeg2Sequence *pSequence) const
{
	// nhĂяo
	if(m_pSequenceHandler)m_pSequenceHandler->OnMpeg2Sequence(this, pSequence);
}

/*
inline const DWORD CMpeg2Parser::FindStartCode(const BYTE *pData, const DWORD dwDataSize)
{
	// Sequence Header Code (0x000001B3) 
	DWORD dwPos;

	for(dwPos = 0UL ; dwPos < dwDataSize ; dwPos++){
		m_dwSyncState <<= 8;
		m_dwSyncState |= (DWORD)pData[dwPos];

		if(m_dwSyncState == 0x000001B3UL){
			// X^[gR[hAVtgWX^
			m_dwSyncState = 0xFFFFFFFFUL;
			break;
			}
		}

	return dwPos;
}
*/




//////////////////////////////////////////////////////////////////////
// CH264AccessUnitNX̍\z/
//////////////////////////////////////////////////////////////////////

#include "Bitstream.h"

//#define STRICT_1SEG	// ZOKi

CH264AccessUnit::CH264AccessUnit()
{
	Reset();
}

CH264AccessUnit::CH264AccessUnit(const CH264AccessUnit &Operand)
{
	*this = Operand;
}

CH264AccessUnit & CH264AccessUnit::operator = (const CH264AccessUnit &Operand)
{
	if (this != &Operand) {
		m_Header = Operand.m_Header;
	}
	return *this;
}

const bool CH264AccessUnit::ParseHeader(void)
{
	if (m_pData[0] != 0 || m_pData[1] != 0 || m_pData[2] != 0x01)
		return false;

	bool bFoundStartCode;
	DWORD Pos = 3;
	do {
		const BYTE NALUnitType = m_pData[Pos++] & 0x1F;

		if (NALUnitType == 0x07) {
			// Sequence parameter set
			CBitstream Bitstream(&m_pData[Pos], m_dwDataSize - Pos);

			m_Header.SPS.ProfileIDC = Bitstream.GetBits(8);
			m_Header.SPS.bConstraintSet0Flag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.bConstraintSet1Flag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.bConstraintSet2Flag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.bConstraintSet3Flag = Bitstream.GetBits(1) != 0;
			if (Bitstream.GetBits(4) != 0)	// reserved_zero_4bits
				return false;
			m_Header.SPS.LevelIDC = Bitstream.GetBits(8);
			m_Header.SPS.SeqParameterSetID = Bitstream.GetUE_V();
			m_Header.SPS.ChromaFormatIDC = 1;
			m_Header.SPS.bSeparateColourPlaneFlag = false;
			m_Header.SPS.BitDepthLumaMinus8 = 0;
			m_Header.SPS.BitDepthChromaMinus8 = 0;
			m_Header.SPS.bQpprimeYZeroTransformBypassFlag = false;
			m_Header.SPS.bSeqScalingMatrixPresentFlag = false;
			if (m_Header.SPS.ProfileIDC == 100
					|| m_Header.SPS.ProfileIDC == 110
					|| m_Header.SPS.ProfileIDC == 122
					|| m_Header.SPS.ProfileIDC == 244
					|| m_Header.SPS.ProfileIDC == 44) {
				// High profile
				m_Header.SPS.ChromaFormatIDC = Bitstream.GetUE_V();
				if (m_Header.SPS.ChromaFormatIDC == 3)	// YUY444
					m_Header.SPS.bSeparateColourPlaneFlag = Bitstream.GetBits(1) != 0;
				m_Header.SPS.BitDepthLumaMinus8 = Bitstream.GetUE_V();
				m_Header.SPS.BitDepthChromaMinus8 = Bitstream.GetUE_V();
				m_Header.SPS.bQpprimeYZeroTransformBypassFlag = Bitstream.GetBits(1) != 0;
				m_Header.SPS.bSeqScalingMatrixPresentFlag = Bitstream.GetBits(1) != 0;
				if (m_Header.SPS.bSeqScalingMatrixPresentFlag) {
					int Length = m_Header.SPS.ChromaFormatIDC != 3 ? 8 : 12;
					for (int i = 0; i < Length; i++) {
						if (Bitstream.GetBits(1)) {	// seq_scaling_list_present_flag
							int LastScale = 8, NextScale = 8;
							for (int j = 0; j < (i < 6 ? 16 : 64); j++) {
								if (NextScale != 0) {
									int DeltaScale = Bitstream.GetSE_V();
									NextScale = (LastScale + DeltaScale + 256) % 256;
									LastScale = NextScale;
								}
							}
						}
					}
				}
			}
			m_Header.SPS.Log2MaxFrameNumMinus4 = Bitstream.GetUE_V();
			m_Header.SPS.PicOrderCntType = Bitstream.GetUE_V();
			if (m_Header.SPS.PicOrderCntType == 0) {
				m_Header.SPS.Log2MaxPicOrderCntLsbMinus4 = Bitstream.GetUE_V();
			} else if (m_Header.SPS.PicOrderCntType == 1) {
				m_Header.SPS.bDeltaPicOrderAlwaysZeroFlag = Bitstream.GetBits(1) != 0;
				m_Header.SPS.OffsetForNonRefPic = Bitstream.GetSE_V();
				m_Header.SPS.OffsetForTopToBottomField = Bitstream.GetSE_V();
				m_Header.SPS.NumRefFramesInPicOrderCntCycle = Bitstream.GetUE_V();
				for (int i = 0; i < m_Header.SPS.NumRefFramesInPicOrderCntCycle; i++)
					Bitstream.GetSE_V();	// offset_for_ref_frame
			}
			m_Header.SPS.NumRefFrames = Bitstream.GetUE_V();
			m_Header.SPS.bGapsInFrameNumValueAllowedFlag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.PicWidthInMbsMinus1 = Bitstream.GetUE_V();
			m_Header.SPS.PicHeightInMapUnitsMinus1 = Bitstream.GetUE_V();
			m_Header.SPS.bFrameMbsOnlyFlag = Bitstream.GetBits(1) != 0;
			if (!m_Header.SPS.bFrameMbsOnlyFlag)
				m_Header.SPS.bMbAdaptiveFrameFieldFlag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.bDirect8x8InferenceFlag = Bitstream.GetBits(1) != 0;
			m_Header.SPS.bFrameCroppingFlag = Bitstream.GetBits(1) != 0;
			if (m_Header.SPS.bFrameCroppingFlag) {
				m_Header.SPS.FrameCropLeftOffset = Bitstream.GetUE_V();
				m_Header.SPS.FrameCropRightOffset = Bitstream.GetUE_V();
				m_Header.SPS.FrameCropTopOffset = Bitstream.GetUE_V();
				m_Header.SPS.FrameCropBottomOffset = Bitstream.GetUE_V();
			}
			m_Header.SPS.bVuiParametersPresentFlag = Bitstream.GetBits(1) != 0;
			if (m_Header.SPS.bVuiParametersPresentFlag) {
				m_Header.SPS.VUI.bAspectRatioInfoPresentFlag = Bitstream.GetBits(1) != 0;
				if (m_Header.SPS.VUI.bAspectRatioInfoPresentFlag) {
					m_Header.SPS.VUI.AspectRatioIDC = Bitstream.GetBits(8);
					if (m_Header.SPS.VUI.AspectRatioIDC == 255) {
						m_Header.SPS.VUI.SarWidth = Bitstream.GetBits(16);
						m_Header.SPS.VUI.SarHeight = Bitstream.GetBits(16);
					}
				}
				// ȉ񂠂邪ȗ
			}
			if (m_Header.SPS.bSeparateColourPlaneFlag)
				m_Header.SPS.ChromaArrayType = m_Header.SPS.ChromaFormatIDC;
			else
				m_Header.SPS.ChromaArrayType = 0;
#ifdef STRICT_1SEG
			// ZOKiɍvĂ?
			if (m_Header.SPS.ProfileIDC != 66
					|| !m_Header.SPS.bConstraintSet0Flag
					|| !m_Header.SPS.bConstraintSet1Flag
					|| !m_Header.SPS.bConstraintSet2Flag
					|| m_Header.SPS.LevelIDC != 12
					|| m_Header.SPS.SeqParameterSetID > 31
					|| m_Header.SPS.Log2MaxFrameNumMinus4 > 12
					|| m_Header.SPS.PicOrderCntType != 2
					|| m_Header.SPS.NumRefFrames == 0
						|| m_Header.SPS.NumRefFrames > 3
					|| m_Header.SPS.bGapsInFrameNumValueAllowedFlag
					|| m_Header.SPS.PicWidthInMbsMinus1 != 19
					|| (m_Header.SPS.PicHeightInMapUnitsMinus1 != 11
						&& m_Header.SPS.PicHeightInMapUnitsMinus1 != 14)
					|| !m_Header.SPS.bFrameMbsOnlyFlag
					|| !m_Header.SPS.bDirect8x8InferenceFlag
					|| (m_Header.SPS.bFrameCroppingFlag !=
						(m_Header.SPS.PicHeightInMapUnitsMinus1 == 11))
					|| (m_Header.SPS.bFrameCroppingFlag
						&& (m_Header.SPS.FrameCropLeftOffset != 0
							|| m_Header.SPS.FrameCropRightOffset != 0
							|| m_Header.SPS.FrameCropTopOffset != 0
							|| m_Header.SPS.FrameCropBottomOffset != 6))
					|| !m_Header.SPS.bVuiParametersPresentFlag) {
				return false;
			}
#endif
			Pos += (Bitstream.GetPos() + 7) >> 3;
		} else if (NALUnitType == 0x09) {
			// Access unit delimiter
			m_Header.AUD.PrimaryPicType = m_pData[Pos] >> 5;
			Pos++;
		}

		DWORD SyncState = 0xFFFFFFFFUL;
		bFoundStartCode = false;
		for (; Pos < m_dwDataSize - 2; Pos++) {
			SyncState = (SyncState << 8) | (DWORD)m_pData[Pos];
			if ((SyncState & 0x00FFFFFF) == 0x00000001UL) {
				bFoundStartCode = true;
				Pos++;
				break;
			}
		}
	} while (bFoundStartCode);

	return true;
}

void CH264AccessUnit::Reset(void)
{
	::ZeroMemory(&m_Header, sizeof(TAG_H264ACCESSUNIT));
}

const WORD CH264AccessUnit::GetHorizontalSize() const
{
	WORD Width = (m_Header.SPS.PicWidthInMbsMinus1 + 1) * 16;
	WORD Crop = m_Header.SPS.FrameCropLeftOffset + m_Header.SPS.FrameCropRightOffset;
	/*
	if (m_Header.SPS.ChromaArrayType != 0)
		Crop *= SubWidthC;
	*/
	return Width - Crop;
}

const WORD CH264AccessUnit::GetVerticalSize() const
{
	WORD Height = (m_Header.SPS.PicHeightInMapUnitsMinus1 + 1) * 16;
	WORD Crop = m_Header.SPS.FrameCropTopOffset + m_Header.SPS.FrameCropBottomOffset;
	if (!m_Header.SPS.bFrameMbsOnlyFlag)
		Height *= 2;
	/*
	if (m_Header.SPS.ChromaArrayType != 0)
		 Crop *= SubHeightC;
	*/
	if (m_Header.SPS.bFrameMbsOnlyFlag)
		Crop *= 2;
	return Height - Crop;
}




//////////////////////////////////////////////////////////////////////
// CH264ParserNX̍\z/
//////////////////////////////////////////////////////////////////////


CH264Parser::CH264Parser(IAccessUnitHandler *pAccessUnitHandler)
	: m_pAccessUnitHandler(pAccessUnitHandler)
{
	Reset();
}

CH264Parser::CH264Parser(const CH264Parser &Operand)
{
	*this = Operand;
}

CH264Parser & CH264Parser::operator = (const CH264Parser &Operand)
{
	// CX^X̃Rs[
	if (&Operand != this) {
		m_pAccessUnitHandler = Operand.m_pAccessUnitHandler;
		m_AccessUnit = Operand.m_AccessUnit;
		m_dwSyncState = Operand.m_dwSyncState;
	}

	return *this;
}

const bool CH264Parser::StorePacket(const CPesPacket *pPacket)
{
	return StoreEs(pPacket->GetPayloadData(), pPacket->GetPayloadSize());
}

const bool CH264Parser::StoreEs(const BYTE *pData, const DWORD dwSize)
{
	bool bTrigger = false;
	DWORD dwPos,dwStart;

	for (dwPos = 0UL ; dwPos < dwSize ; dwPos += dwStart) {
		// Access unit delimiter
		DWORD Remain = dwSize - dwPos;
		DWORD SyncState = m_dwSyncState;
		for (dwStart = 0UL ; dwStart < Remain ; dwStart++) {
			SyncState = (SyncState << 8) | (DWORD)pData[dwStart + dwPos];
			if ((SyncState & 0xFFFFFF1F) == 0x00000109UL) {
				// Access unit delimiter
				break;
			}
		}

		if (dwStart < Remain) {
			dwStart++;
			if (m_AccessUnit.GetSize() >= 4) {
				if (dwStart > 4) {
					m_AccessUnit.AddData(&pData[dwPos], dwStart - 4);
				} else if (dwStart < 4) {
					// X^[gR[h̒fЂ菜
					m_AccessUnit.TrimTail(4 - dwStart);
				}

				// V[PXo͂
				if (m_AccessUnit.ParseHeader())
					OnAccessUnit(&m_AccessUnit);
			}

			// X^[gR[hZbg
			BYTE StartCode[4];
			StartCode[0] = (BYTE)(SyncState >> 24);
			StartCode[1] = (BYTE)((SyncState >> 16) & 0xFF);
			StartCode[2] = (BYTE)((SyncState >> 8) & 0xFF);
			StartCode[3] = (BYTE)(SyncState & 0xFF);
			m_AccessUnit.SetData(StartCode, 4);

			// VtgWX^
			m_dwSyncState = 0xFFFFFFFFUL;
			bTrigger = true;
		} else if (m_AccessUnit.GetSize() >= 4) {
			// V[PXXgA
			if (m_AccessUnit.AddData(&pData[dwPos], Remain) >= 0x1000000UL) {
				// O(V[PX16MB𒴂)
				m_AccessUnit.ClearSize();
			}
		}
	}

	return bTrigger;
}

void CH264Parser::Reset(void)
{
	// Ԃ
	m_dwSyncState = 0xFFFFFFFFUL;

	m_AccessUnit.Reset();
}

void CH264Parser::OnPesPacket(const CPesParser *pPesParser, const CPesPacket *pPacket)
{
	// CPesParser::IPacketHandlerC^tF[X̎
	StorePacket(pPacket);
}

void CH264Parser::OnAccessUnit(const CH264AccessUnit *pAccessUnit) const
{
	// nhĂяo
	if (m_pAccessUnitHandler)
		m_pAccessUnitHandler->OnAccessUnit(this, pAccessUnit);
}
